<?php

declare(strict_types=1);

namespace Drupal\ui_patterns\Plugin\UiPatterns\PropType;

use Drupal\Core\StringTranslation\TranslatableMarkup;
use Drupal\ui_patterns\Attribute\PropType;
use Drupal\ui_patterns\PropTypePluginBase;

/**
 * Provides a 'Machine name' PropType.
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/CSS/ident
 */
#[PropType(
  id: 'identifier',
  label: new TranslatableMarkup('Identifier'),
  description: new TranslatableMarkup('A string with restricted characters, suitable for an HTML ID.'),
  default_source: 'textfield',
  schema: ['type' => 'string', 'pattern' => '(?:--|-?[A-Za-z_\x{00A0}-\x{10FFFF}])[A-Za-z0-9-_\x{00A0}-\x{10FFFF}\.]*'],
  priority: 100
)]
class IdentifierPropType extends PropTypePluginBase {

}
